﻿// <auto-generated />
using System.Collections.Generic;
using Foxnouns.Backend.Database;
using Foxnouns.Backend.Database.Models;
using Microsoft.EntityFrameworkCore;
using Microsoft.EntityFrameworkCore.Infrastructure;
using Microsoft.EntityFrameworkCore.Storage.ValueConversion;
using NodaTime;
using Npgsql.EntityFrameworkCore.PostgreSQL.Metadata;

#nullable disable

namespace Foxnouns.Backend.Database.Migrations
{
    [DbContext(typeof(DatabaseContext))]
    partial class DatabaseContextModelSnapshot : ModelSnapshot
    {
        protected override void BuildModel(ModelBuilder modelBuilder)
        {
#pragma warning disable 612, 618
            modelBuilder
                .HasAnnotation("ProductVersion", "9.0.0")
                .HasAnnotation("Relational:MaxIdentifierLength", 63);

            NpgsqlModelBuilderExtensions.UseIdentityByDefaultColumns(modelBuilder);

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.Application", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    b.Property<string>("ClientId")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("client_id");

                    b.Property<string>("ClientSecret")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("client_secret");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.PrimitiveCollection<string[]>("RedirectUris")
                        .IsRequired()
                        .HasColumnType("text[]")
                        .HasColumnName("redirect_uris");

                    b.PrimitiveCollection<string[]>("Scopes")
                        .IsRequired()
                        .HasColumnType("text[]")
                        .HasColumnName("scopes");

                    b.HasKey("Id")
                        .HasName("pk_applications");

                    b.ToTable("applications", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.AuthMethod", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    b.Property<int>("AuthType")
                        .HasColumnType("integer")
                        .HasColumnName("auth_type");

                    b.Property<long?>("FediverseApplicationId")
                        .HasColumnType("bigint")
                        .HasColumnName("fediverse_application_id");

                    b.Property<string>("RemoteId")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("remote_id");

                    b.Property<string>("RemoteUsername")
                        .HasColumnType("text")
                        .HasColumnName("remote_username");

                    b.Property<long>("UserId")
                        .HasColumnType("bigint")
                        .HasColumnName("user_id");

                    b.HasKey("Id")
                        .HasName("pk_auth_methods");

                    b.HasIndex("FediverseApplicationId")
                        .HasDatabaseName("ix_auth_methods_fediverse_application_id");

                    b.HasIndex("UserId")
                        .HasDatabaseName("ix_auth_methods_user_id");

                    b.HasIndex("AuthType", "RemoteId")
                        .IsUnique()
                        .HasDatabaseName("ix_auth_methods_auth_type_remote_id")
                        .HasFilter("fediverse_application_id IS NULL");

                    b.HasIndex("AuthType", "RemoteId", "FediverseApplicationId")
                        .IsUnique()
                        .HasDatabaseName("ix_auth_methods_auth_type_remote_id_fediverse_application_id")
                        .HasFilter("fediverse_application_id IS NOT NULL");

                    b.ToTable("auth_methods", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.DataExport", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    b.Property<string>("Filename")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("filename");

                    b.Property<long>("UserId")
                        .HasColumnType("bigint")
                        .HasColumnName("user_id");

                    b.HasKey("Id")
                        .HasName("pk_data_exports");

                    b.HasIndex("Filename")
                        .IsUnique()
                        .HasDatabaseName("ix_data_exports_filename");

                    b.HasIndex("UserId")
                        .HasDatabaseName("ix_data_exports_user_id");

                    b.ToTable("data_exports", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.FediverseApplication", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    b.Property<string>("ClientId")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("client_id");

                    b.Property<string>("ClientSecret")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("client_secret");

                    b.Property<string>("Domain")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("domain");

                    b.Property<int>("InstanceType")
                        .HasColumnType("integer")
                        .HasColumnName("instance_type");

                    b.HasKey("Id")
                        .HasName("pk_fediverse_applications");

                    b.ToTable("fediverse_applications", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.Member", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    b.Property<string>("Avatar")
                        .HasColumnType("text")
                        .HasColumnName("avatar");

                    b.Property<string>("Bio")
                        .HasColumnType("text")
                        .HasColumnName("bio");

                    b.Property<string>("DisplayName")
                        .HasColumnType("text")
                        .HasColumnName("display_name");

                    b.Property<List<Field>>("Fields")
                        .IsRequired()
                        .HasColumnType("jsonb")
                        .HasColumnName("fields");

                    b.PrimitiveCollection<string[]>("Links")
                        .IsRequired()
                        .HasColumnType("text[]")
                        .HasColumnName("links");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.Property<List<FieldEntry>>("Names")
                        .IsRequired()
                        .HasColumnType("jsonb")
                        .HasColumnName("names");

                    b.Property<List<Pronoun>>("Pronouns")
                        .IsRequired()
                        .HasColumnType("jsonb")
                        .HasColumnName("pronouns");

                    b.Property<string>("Sid")
                        .IsRequired()
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text")
                        .HasColumnName("sid")
                        .HasDefaultValueSql("find_free_member_sid()");

                    b.Property<bool>("Unlisted")
                        .HasColumnType("boolean")
                        .HasColumnName("unlisted");

                    b.Property<long>("UserId")
                        .HasColumnType("bigint")
                        .HasColumnName("user_id");

                    b.HasKey("Id")
                        .HasName("pk_members");

                    b.HasIndex("Sid")
                        .IsUnique()
                        .HasDatabaseName("ix_members_sid");

                    b.HasIndex("UserId", "Name")
                        .IsUnique()
                        .HasDatabaseName("ix_members_user_id_name");

                    b.ToTable("members", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.MemberFlag", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<long>("Id"));

                    b.Property<long>("MemberId")
                        .HasColumnType("bigint")
                        .HasColumnName("member_id");

                    b.Property<long>("PrideFlagId")
                        .HasColumnType("bigint")
                        .HasColumnName("pride_flag_id");

                    b.HasKey("Id")
                        .HasName("pk_member_flags");

                    b.HasIndex("MemberId")
                        .HasDatabaseName("ix_member_flags_member_id");

                    b.HasIndex("PrideFlagId")
                        .HasDatabaseName("ix_member_flags_pride_flag_id");

                    b.ToTable("member_flags", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.PrideFlag", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    b.Property<string>("Description")
                        .HasColumnType("text")
                        .HasColumnName("description");

                    b.Property<string>("Hash")
                        .HasColumnType("text")
                        .HasColumnName("hash");

                    b.Property<string>("Name")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("name");

                    b.Property<long>("UserId")
                        .HasColumnType("bigint")
                        .HasColumnName("user_id");

                    b.HasKey("Id")
                        .HasName("pk_pride_flags");

                    b.HasIndex("UserId")
                        .HasDatabaseName("ix_pride_flags_user_id");

                    b.ToTable("pride_flags", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.TemporaryKey", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<long>("Id"));

                    b.Property<Instant>("Expires")
                        .HasColumnType("timestamp with time zone")
                        .HasColumnName("expires");

                    b.Property<string>("Key")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("key");

                    b.Property<string>("Value")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("value");

                    b.HasKey("Id")
                        .HasName("pk_temporary_keys");

                    b.HasIndex("Key")
                        .IsUnique()
                        .HasDatabaseName("ix_temporary_keys_key");

                    b.ToTable("temporary_keys", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.Token", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    b.Property<long>("ApplicationId")
                        .HasColumnType("bigint")
                        .HasColumnName("application_id");

                    b.Property<Instant>("ExpiresAt")
                        .HasColumnType("timestamp with time zone")
                        .HasColumnName("expires_at");

                    b.Property<byte[]>("Hash")
                        .IsRequired()
                        .HasColumnType("bytea")
                        .HasColumnName("hash");

                    b.Property<bool>("ManuallyExpired")
                        .HasColumnType("boolean")
                        .HasColumnName("manually_expired");

                    b.PrimitiveCollection<string[]>("Scopes")
                        .IsRequired()
                        .HasColumnType("text[]")
                        .HasColumnName("scopes");

                    b.Property<long>("UserId")
                        .HasColumnType("bigint")
                        .HasColumnName("user_id");

                    b.HasKey("Id")
                        .HasName("pk_tokens");

                    b.HasIndex("ApplicationId")
                        .HasDatabaseName("ix_tokens_application_id");

                    b.HasIndex("UserId")
                        .HasDatabaseName("ix_tokens_user_id");

                    b.ToTable("tokens", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.User", b =>
                {
                    b.Property<long>("Id")
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    b.Property<string>("Avatar")
                        .HasColumnType("text")
                        .HasColumnName("avatar");

                    b.Property<string>("Bio")
                        .HasColumnType("text")
                        .HasColumnName("bio");

                    b.Property<Dictionary<Snowflake, User.CustomPreference>>("CustomPreferences")
                        .IsRequired()
                        .HasColumnType("jsonb")
                        .HasColumnName("custom_preferences");

                    b.Property<bool>("Deleted")
                        .HasColumnType("boolean")
                        .HasColumnName("deleted");

                    b.Property<Instant?>("DeletedAt")
                        .HasColumnType("timestamp with time zone")
                        .HasColumnName("deleted_at");

                    b.Property<long?>("DeletedBy")
                        .HasColumnType("bigint")
                        .HasColumnName("deleted_by");

                    b.Property<string>("DisplayName")
                        .HasColumnType("text")
                        .HasColumnName("display_name");

                    b.Property<List<Field>>("Fields")
                        .IsRequired()
                        .HasColumnType("jsonb")
                        .HasColumnName("fields");

                    b.Property<Instant>("LastActive")
                        .HasColumnType("timestamp with time zone")
                        .HasColumnName("last_active");

                    b.Property<Instant>("LastSidReroll")
                        .HasColumnType("timestamp with time zone")
                        .HasColumnName("last_sid_reroll");

                    b.PrimitiveCollection<string[]>("Links")
                        .IsRequired()
                        .HasColumnType("text[]")
                        .HasColumnName("links");

                    b.Property<bool>("ListHidden")
                        .HasColumnType("boolean")
                        .HasColumnName("list_hidden");

                    b.Property<string>("MemberTitle")
                        .HasColumnType("text")
                        .HasColumnName("member_title");

                    b.Property<List<FieldEntry>>("Names")
                        .IsRequired()
                        .HasColumnType("jsonb")
                        .HasColumnName("names");

                    b.Property<string>("Password")
                        .HasColumnType("text")
                        .HasColumnName("password");

                    b.Property<List<Pronoun>>("Pronouns")
                        .IsRequired()
                        .HasColumnType("jsonb")
                        .HasColumnName("pronouns");

                    b.Property<int>("Role")
                        .HasColumnType("integer")
                        .HasColumnName("role");

                    b.Property<UserSettings>("Settings")
                        .IsRequired()
                        .HasColumnType("jsonb")
                        .HasColumnName("settings");

                    b.Property<string>("Sid")
                        .IsRequired()
                        .ValueGeneratedOnAdd()
                        .HasColumnType("text")
                        .HasColumnName("sid")
                        .HasDefaultValueSql("find_free_user_sid()");

                    b.Property<string>("Timezone")
                        .HasColumnType("text")
                        .HasColumnName("timezone");

                    b.Property<string>("Username")
                        .IsRequired()
                        .HasColumnType("text")
                        .HasColumnName("username");

                    b.HasKey("Id")
                        .HasName("pk_users");

                    b.HasIndex("Sid")
                        .IsUnique()
                        .HasDatabaseName("ix_users_sid");

                    b.HasIndex("Username")
                        .IsUnique()
                        .HasDatabaseName("ix_users_username");

                    b.ToTable("users", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.UserFlag", b =>
                {
                    b.Property<long>("Id")
                        .ValueGeneratedOnAdd()
                        .HasColumnType("bigint")
                        .HasColumnName("id");

                    NpgsqlPropertyBuilderExtensions.UseIdentityByDefaultColumn(b.Property<long>("Id"));

                    b.Property<long>("PrideFlagId")
                        .HasColumnType("bigint")
                        .HasColumnName("pride_flag_id");

                    b.Property<long>("UserId")
                        .HasColumnType("bigint")
                        .HasColumnName("user_id");

                    b.HasKey("Id")
                        .HasName("pk_user_flags");

                    b.HasIndex("PrideFlagId")
                        .HasDatabaseName("ix_user_flags_pride_flag_id");

                    b.HasIndex("UserId")
                        .HasDatabaseName("ix_user_flags_user_id");

                    b.ToTable("user_flags", (string)null);
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.AuthMethod", b =>
                {
                    b.HasOne("Foxnouns.Backend.Database.Models.FediverseApplication", "FediverseApplication")
                        .WithMany()
                        .HasForeignKey("FediverseApplicationId")
                        .HasConstraintName("fk_auth_methods_fediverse_applications_fediverse_application_id");

                    b.HasOne("Foxnouns.Backend.Database.Models.User", "User")
                        .WithMany("AuthMethods")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_auth_methods_users_user_id");

                    b.Navigation("FediverseApplication");

                    b.Navigation("User");
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.DataExport", b =>
                {
                    b.HasOne("Foxnouns.Backend.Database.Models.User", "User")
                        .WithMany("DataExports")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_data_exports_users_user_id");

                    b.Navigation("User");
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.Member", b =>
                {
                    b.HasOne("Foxnouns.Backend.Database.Models.User", "User")
                        .WithMany("Members")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_members_users_user_id");

                    b.Navigation("User");
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.MemberFlag", b =>
                {
                    b.HasOne("Foxnouns.Backend.Database.Models.Member", null)
                        .WithMany("ProfileFlags")
                        .HasForeignKey("MemberId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_member_flags_members_member_id");

                    b.HasOne("Foxnouns.Backend.Database.Models.PrideFlag", "PrideFlag")
                        .WithMany()
                        .HasForeignKey("PrideFlagId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_member_flags_pride_flags_pride_flag_id");

                    b.Navigation("PrideFlag");
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.PrideFlag", b =>
                {
                    b.HasOne("Foxnouns.Backend.Database.Models.User", null)
                        .WithMany("Flags")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_pride_flags_users_user_id");
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.Token", b =>
                {
                    b.HasOne("Foxnouns.Backend.Database.Models.Application", "Application")
                        .WithMany()
                        .HasForeignKey("ApplicationId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_tokens_applications_application_id");

                    b.HasOne("Foxnouns.Backend.Database.Models.User", "User")
                        .WithMany()
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_tokens_users_user_id");

                    b.Navigation("Application");

                    b.Navigation("User");
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.UserFlag", b =>
                {
                    b.HasOne("Foxnouns.Backend.Database.Models.PrideFlag", "PrideFlag")
                        .WithMany()
                        .HasForeignKey("PrideFlagId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_user_flags_pride_flags_pride_flag_id");

                    b.HasOne("Foxnouns.Backend.Database.Models.User", null)
                        .WithMany("ProfileFlags")
                        .HasForeignKey("UserId")
                        .OnDelete(DeleteBehavior.Cascade)
                        .IsRequired()
                        .HasConstraintName("fk_user_flags_users_user_id");

                    b.Navigation("PrideFlag");
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.Member", b =>
                {
                    b.Navigation("ProfileFlags");
                });

            modelBuilder.Entity("Foxnouns.Backend.Database.Models.User", b =>
                {
                    b.Navigation("AuthMethods");

                    b.Navigation("DataExports");

                    b.Navigation("Flags");

                    b.Navigation("Members");

                    b.Navigation("ProfileFlags");
                });
#pragma warning restore 612, 618
        }
    }
}
